/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2008 by TAKAGI Nobuhisa
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */
#include <new>
#include <map>
#include "toppers/global.hpp"

namespace toppers
{

  /*!
   *  \brief  O[oIuWFNgւ̃ANZbT
   *  \param[in]  key   IuWFNg
   *  \return     key Ŏw肵IuWFNgւ̎Q
   *
   *  O[oIuWFNgւ̃ANZXꌳǗB
   *  ̊֐ăO[oANZXsƂɂAʏ̐ÓIIuWFNgI
   *  Ɋւ肪B
   *  ܂AIɊǗĂIuWFNǵAvOIɃfXgN^Ă΂邱Ƃ͂ȂB
   *  iɂ΃[Nɂ邪AQ͂ƂɂȂj
   */
  boost::any& global( std::string const& key )
  {
    static std::map< std::string, boost::any >* gvm = 0;
    if ( gvm == 0 )
    {
      union max_aligner
      {
        long long ll;
        double d;
        long double ld;
        void* pv;
        void (*pfn)();
      };
      const std::size_t size = ( sizeof( std::map< std::string, boost::any > ) + sizeof( max_aligner ) - 1 ) / sizeof( max_aligner );
      static max_aligner gvm_storage[ size ];
      gvm = new ( gvm_storage ) std::map< std::string, boost::any >;  // fXgN^͌Ă΂Ȃ
    }
    return ( *gvm )[key];
  }

}
